
// loader/converter for .rgb.gz pictures - copyleft 1978 brioche/aspirine 
// Take care: GZ_Error exception might be raised at anytime by this class...

#ifndef _LOADER_H_INCLUDED
#define _LOADER_H_INCLUDED

#include <iostream>
#include <cstring>
#include <ptc.h>
#include "rgb32.h"
#include "GZ.h"

class Loader {
	GZ_Stream *gzs;
	GZ_Buffer *gzb;
	bool verb;
public:
	Loader( bool verbose = false, int granularity = 8*1024 );
	~Loader();
	void load( const char *filename, int size, char8 *buffer );	
	void load( const char *filename, int w, int h, int32 *buffer );	
};

#endif // _LOADER_H_INCLUDED

